function varargout = TipTrack(varargin)
% TIPTRACK MATLAB code for TipTrack.fig
%      TIPTRACK, by itself, creates a new TIPTRACK or raises the existing
%      singleton*.
%
%      H = TIPTRACK returns the handle to a new TIPTRACK or the handle to
%      the existing singleton*.
%
%      TIPTRACK('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in TIPTRACK.M with the given input arguments.
%
%      TIPTRACK('Property','Value',...) creates a new TIPTRACK or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before TipTrack_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to TipTrack_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help TipTrack

% Last Modified by GUIDE v2.5 07-Dec-2016 11:29:27

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @TipTrack_OpeningFcn, ...
                   'gui_OutputFcn',  @TipTrack_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT
global stopped;
% --- Executes just before TipTrack is made visible.
function TipTrack_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to TipTrack (see VARARGIN)

% Choose default command line output for TipTrack
handles.output = hObject;
fclose('all');
hhh1=KillTT;  % emergency stop button
drawnow;
movegui(hhh1,'north');
addpath(pwd);
axes(handles.growth);
axis off;axis equal;
uiwait(msgbox('Please load TipTracker workspace configuration in ZEN, maximize the Zen window, close all open images, then press OK and let go of the mouse','','warn'));
pause(0.5);
drawnow;
uiwait(msgbox('Please set up your time series','','warn'));
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes TipTrack wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = TipTrack_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.pushbutton2, 'Enable','on');
set(handles.pushbutton1, 'Enable','off');
set(handles.pushbutton3, 'Enable','off');
set(handles.pushbutton4, 'Enable','off');
set(handles.text6, 'String',num2str(0));
set(handles.text5, 'String',datestr(now));
axes(handles.growth);
cla;
global stopped;
stopped=0;
mydir=get(handles.edit2, 'String');
logfilename=[mydir filesep get(handles.edit5, 'String') '.txt'];
maxxshift=str2double(get(handles.edit7, 'String'));
maxyshift=str2double(get(handles.edit8, 'String'));
maxzshift=str2double(get(handles.edit9, 'String'));
fidlogfile = fopen(logfilename,'a');
absstarttime=clock;
[npositions,xstart,ystart,zstart]=readpositionslist(get(handles.edit6, 'String'));
inrange=ones(npositions,1);  % keeps track which samples are in the accessible region 
set(handles.text4, 'String','');
% main loop: time series
while (str2double(get(handles.text6, 'String'))< str2double(get(handles.edit3, 'String'))) && not(stopped)
    starttime=clock;
    currentRep=str2double(get(handles.text6, 'String'))+1;  %current time point
    set(handles.text6, 'String',num2str(currentRep));
    if currentRep>1
        oldoutname=outname;
    end
    outname=[get(handles.edit5, 'String') sprintf('%04d',currentRep)];

    drawnow;
    mycommand =['loadpositionlist.exe "' get(handles.edit6, 'String') '"'];   %Zen: load position list
    disp(mycommand);
    drawnow;
    system(mycommand);

    mycommand =['startexperiment.exe "' mydir '" "' outname '.lsm" ' num2str(currentRep)]; %Zen: start acquisition and save images
    disp(mycommand);
    h = waitbar(0,'0','Name','Waiting for ZEN...');
    drawnow;
    system(mycommand);
    close(h);
    if currentRep>1
       [mm1, imageinfo1]=loadLSMfileMP([mydir '\' oldoutname '.lsm'],npositions); % max projection of previous time point
       [mm2, ~]=loadLSMfileMP([mydir '\' outname '.lsm'],npositions); % max projection of current time point
       [ysn, xsn]=calcShift(mm1,mm2,npositions);   %  estimate movement;  x and y swapped at vertical confocal
       ysn=ysn.*(-1); xsn=xsn.*(-1);  % confocal orientation 
       xs=xs+xsn;  % estimated future position = current position + previous movement
       ys=ys+ysn;
       xp(end+1,:)=xp(end,:)+xs;   % path of sample
       yp(end+1,:)=yp(end,:)+ys;
       axes(handles.growth);
       hold all;
       for pp=1:npositions 
           plot(xp(:,pp),yp(:,pp));  % visualize path
           tline = ['t = \t' num2str(etime(clock,absstarttime)) '\tdt = \t' num2str(etime(clock,starttime)) ...
                    't\tn = \t' num2str(currentRep) '\tPosition = \t' num2str(pp) ...
                    '\t dx = \t' num2str(imageinfo1.VoxelSizeX*1E6*xp(end,pp)) ...
                    '\t dy = \t' num2str(imageinfo1.VoxelSizeY*1E6*yp(end,pp)) '\r\n'];
           fprintf(fidlogfile,tline);  % write protocol file
       end
       axis off;axis equal;
       hold off
       mycommand =['copy "' get(handles.edit6, 'String') '","' get(handles.edit6, 'String') num2str(currentRep) '"'];
       disp(mycommand);
       drawnow;
       system(mycommand); %backup position file
       % create new position file
       [n,x,y,z]=readpositionslist(get(handles.edit6, 'String'));
       % 
       for kj=1:npositions
           if (abs(x(kj)-xstart(kj))>maxxshift) || (abs(y(kj)-ystart(kj))>maxyshift) || (abs(z(kj)-zstart(kj))>maxzshift)
               inrange(kj)=0;
           end
       end
       shiftandsavepositionlist(get(handles.edit6, 'String'), n, xs,ys,xs.*0, x,y,z, imageinfo1.VoxelSizeX*1E6,imageinfo1.VoxelSizeY*1E6,imageinfo1.VoxelSizeZ*1E6, inrange);
       if max(inrange)<1
           stopped=1;
       end
       if min(inrange)<1
           set(handles.text4, 'String', ['OUT OF RANGE! ' num2str(not(inrange'))]);
       end
    else
        xs=zeros(1,npositions);ys=xs;xp=xs;yp=xs;xsn=xs;ysn=xs;
    end
    tt=0;
    % wait until next time point
    while (etime(clock,starttime)<str2double(get(handles.edit4, 'String'))) && not(stopped)
        pause(0.2);
        tt=tt+1;
        if tt==4
           tt=0;
           waitmore=str2double(get(handles.edit4, 'String'))-etime(clock,starttime);
           set(handles.text9, 'String', num2str(round(waitmore)));
           drawnow;
        end
    end
end
fclose(fidlogfile);
set(handles.pushbutton2, 'Enable','off');
set(handles.pushbutton1, 'Enable','off');
set(handles.pushbutton3, 'Enable','on');
set(handles.pushbutton4, 'Enable','off');
guidata(hObject, handles);


% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global stopped;
stopped=1;
guidata(hObject, handles);

% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.edit2, 'String',uigetdir);
if strcmp(get(handles.edit5, 'String'),'Prefix')
    set(handles.edit5, 'String',[date '_']);
end
set(handles.pushbutton4, 'Enable','on');
guidata(hObject, handles);


function edit2_Callback(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit2 as text
%        str2double(get(hObject,'String')) returns contents of edit2 as a double


% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit3_Callback(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit3 as text
%        str2double(get(hObject,'String')) returns contents of edit3 as a double


% --- Executes during object creation, after setting all properties.
function edit3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit4_Callback(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit4 as text
%        str2double(get(hObject,'String')) returns contents of edit4 as a double
if str2double(get(handles.edit4, 'String'))<20
   set(handles.edit4, 'String','20');
end
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function edit4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit5_Callback(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit5 as text
%        str2double(get(hObject,'String')) returns contents of edit5 as a double


% --- Executes during object creation, after setting all properties.
function edit5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit6_Callback(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit6 as text
%        str2double(get(hObject,'String')) returns contents of edit6 as a double


% --- Executes during object creation, after setting all properties.
function edit6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
currentD=pwd;
cd(get(handles.edit2, 'String'));
[posFileName,posPathName]=uigetfile('*.pos','Select position file');
set(handles.edit6, 'String',[posPathName posFileName]);
set(handles.pushbutton1, 'Enable','on');
cd(currentD);
guidata(hObject, handles);


% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
delete(hObject);
clear global;
fclose('all');

drawnow;
system(mycommand);
disp('Done with cleanup');



function edit7_Callback(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit7 as text
%        str2double(get(hObject,'String')) returns contents of edit7 as a double


% --- Executes during object creation, after setting all properties.
function edit7_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit8_Callback(hObject, eventdata, handles)
% hObject    handle to edit8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit8 as text
%        str2double(get(hObject,'String')) returns contents of edit8 as a double


% --- Executes during object creation, after setting all properties.
function edit8_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit8 (see GCBO)
% % eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit9_Callback(hObject, eventdata, handles)
% hObject    handle to edit9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit9 as text
%        str2double(get(hObject,'String')) returns contents of edit9 as a double


% --- Executes during object creation, after setting all properties.
function edit9_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
