function [xshift yshift] = calcShift(im1F, im2F, positions)
% estimates the lateral shift of images im2 relative to im1 (result is in pixels)
for i=1:positions
    im1=squeeze(im1F(:,:,i));
    im2=squeeze(im2F(:,:,i));
    sx=size(im1,1);
    sy=size(im1,2);
    % cf defines the target region of im2 that is being located in im1
    cf=im2(round(sx/3):round(sx/3*2),round(sy/3):round(sy/3*2)); 
     
    try
        where=normxcorr2(cf,im1);
        [a y(1)]=max(max(where));
        [a x(1)]=max(max(where'));
        
        cf_median= medfilt2(cf, [8 8]);
        where=normxcorr2(cf_median,medfilt2(im1, [8 8]));
        [a y(2)]=max(max(where));
        [a x(2)]=max(max(where'));
        
        h = fspecial('average', 8);
        cf_mean=filter2(h, cf);
        where=normxcorr2(cf_mean,filter2(h, im1));
        [a y(3)]=max(max(where));
        [a x(3)]=max(max(where'));
        
        % remove eventual outlier result
        xshift(i)=fix(median(sx/3*2-x));
        yshift(i)=fix(median(sy/3*2-y));
        
    catch
        %happens if im1/cf are 0   (e.g. if 1 root fell off the agarose
        %plate)
        xshift(i)=0;
        yshift(i)=0;
    end;
    
end;

end