function [im, imageinfo] = loadLSMfile(imagename,npositions)
% loads a .lsm file and returns a maximum projection (z and all channels)
% for each position

imageinfo=lsminfo(imagename);
a=tiffread32(imagename);
imdata=zeros(imageinfo.DIMENSIONS(3),imageinfo.DIMENSIONS(2),imageinfo.DIMENSIONS(1),imageinfo.NUMBER_OF_CHANNELS,npositions);


if imageinfo.NUMBER_OF_CHANNELS>1
    for p=1:npositions
        for i=1:imageinfo.DIMENSIONS(3);
            for j=1:imageinfo.NUMBER_OF_CHANNELS;
                imdata(i,:,:,j,p)=double(a((p-1)*imageinfo.DIMENSIONS(3)+i).data{j});
            end;
        end;
    end;
else
    for p=1:npositions
        for i=1:imageinfo.DIMENSIONS(3);
            imdata(i,:,:,1,p)=double(a((p-1)*imageinfo.DIMENSIONS(3)+i).data);
        end;
    end;
end;

 if size(imdata, 1)> 1 
     mm1=max(imdata,[],1);
 else
     mm1=imdata;
 end;
 if size(mm1,4)>1
     mm2=max(mm1,[],4);
 else
     mm2=mm1;
 end;
 im=squeeze(mm2);